package jalview.ws;

import jalview.ws.api.ServiceWithParameters;

import java.net.URL;
import java.util.List;
import java.util.concurrent.Future;

public interface WSDiscovererI
{
  public static final int STATUS_OK = 1;
  public static final int STATUS_NO_SERVICES = 0;
  public static final int STATUS_INVALID = -1;
  public static final int STATUS_UNKNOWN = -2;

  public void setServiceUrls(List<String> wsUrls);

  public List<String> getServiceUrls();

  public List<ServiceWithParameters> getServices();

  public boolean testServiceUrl(URL url);

  public int getServerStatusFor(String url);
  
  public void addServiceChangeListener(ServiceChangeListener listener);
  
  public void removeServiceChangeListener(ServiceChangeListener listener);

  public Future<WSDiscovererI> startDiscoverer();

  public String getErrorMessages();

  public boolean hasServices();

  public boolean isRunning();
}
